OPTION EXPR32
OPTION CASEMAP:NONE
OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

.486
.MODEL FLAT

INCLUDELIB Kernel32.lib

GetCommandLineA PROTO STDCALL

EXTERNDEF nArgc:DWORD
EXTERNDEF rgArgv:DWORD
EXTERNDEF bfArgv:BYTE

.DATA
nArgc DWORD 0
rgArgv DWORD OFFSET rgpArgv
rgpArgv DWORD 22h DUP(0)
bfArgv BYTE 100h DUP(0)

.CODE
ALIGN 16
GetArgs PROC STDCALL
    CMP bfArgv,0
    JNE Done
    PUSH esi
    PUSH edi
    CALL GetCommandLineA
    MOV esi,eax
    MOV edi,OFFSET bfArgv
    MOV edx,rgArgv
    XOR eax,eax
    MOV nArgc,0
    CLD
@@: CMP BYTE PTR [esi],0
    JE @F
        JMP NoWhiteSpace
        WhiteSpace:
            INC esi
        NoWhiteSpace:
        CMP BYTE PTR [esi],' '
        JE WhiteSpace
        CMP BYTE PTR [esi],9
        JE WhiteSpace
        CMP BYTE PTR [esi],0
        JE @F
        CMP BYTE PTR [esi],'"'
        JNE ShortArg
        LongArg:
            MOV DWORD PTR [edx],edi
            INC nArgc
            INC esi
            LongArgStart:
                CMP BYTE PTR [esi],'"'
                JE LongArgEnd
                CMP BYTE PTR [esi],0
                JE @F
                MOVSB
            JMP LongArgStart
            LongArgEnd:
        JMP NextArg
        ShortArg:
            MOV DWORD PTR [edx],edi
            INC nArgc
            ShortArgStart:
                CMP BYTE PTR [esi],' '
                JE NextArg
                CMP BYTE PTR [esi],0
                JE @F
                CMP BYTE PTR [esi],'"'
                JNE StillShort
                    STOSB
                    ADD edx,4
                    JMP LongArg
                StillShort:
                MOVSB
            JMP ShortArgStart
        NextArg:
        INC esi
        STOSB
        ADD edx,4
    JMP @B
@@: POP edi
    POP esi
    Done:
    MOV eax,nArgc
    MOV edx,rgArgv
    RET
GetArgs ENDP
END